<?php

namespace Ems\Controllers;

use Exception\Messages;
use Service\LogService;
use Service\OAuth\OAuthCustomImpl;
use Zeedhi\Framework\Controller\Simple;
use Zeedhi\Framework\HTTP\Kernel;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Error;


use Ems\Services\OperadorService;

class OperadorController {
    /** @var OperadorService */
    protected $operadorService;

    public function __construct(OperadorService $operadorService) {
        $this->operadorService = $operadorService;
    }

    public function restringeApenasMarcacaoPG(Request\Row $request, Response $response) {
        try {
            $row = $request->getRow();

            $cdOperador = $row['CDOPERADOR'];

            $success = $this->operadorService->restringeApenasMarcacaoPG($cdOperador);

            $dataset = [
                'success' => $success
            ];

            $response->addDataSet(new DataSet('restringeApenasMarcacaoPG', $dataset));
        } catch(\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode(), $e->getTrace()));
        }
    }

    public function removeRestricaoApenasMarcacaoPG(Request\Row $request, Response $response) {
        try {
            $row = $request->getRow();

            $cdOperador = $row['CDOPERADOR'];

            $success = $this->operadorService->removeRestricaoApenasMarcacaoPG($cdOperador);

            $dataset = [
                'success' => $success
            ];

            $response->addDataSet(new DataSet('removeRestricaoApenasMarcacaoPG', $dataset));
        } catch(\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode(), $e->getTrace()));
        }
    }
}
