<?php
namespace Service\Hcm;

class EscalaService {

    private $entityManager;

    public function __construct(\Doctrine\ORM\EntityManager $entityManager)
    {
        $this->entityManager = $entityManager;
    }

    public function getAlteracoesEscala($dtinicio, $dtfim, $nrvinculom, $dtmescompetencia, $nrorg) {
        try {
            $query = <<<SQL
SELECT
    NVL(VM.CDMATRICULA, VM.NRVINCULOM)    "registration_number",
    TO_CHAR(AE.DTINIESCALA, 'DD/MM/YYYY') "initial_date",
    AE.NRTURNO                            "shift_id",
    TO_CHAR(AE.DTINIESCALA, 'D')          "shift_day_id",
    AE.*
FROM
         GPE_ALTEESCALA AE
    JOIN GPE_VINCULOM VM ON VM.NRVINCULOM = AE.NRVINCULOM
                            AND VM.NRORG = AE.NRORG
    JOIN GPE_VINCULOH VH ON VH.NRVINCULOM = VM.NRVINCULOM
                            AND VH.NRORG = VM.NRORG
                            AND VH.DTMESCOMPETENC = (
        SELECT
            MAX(H1.DTMESCOMPETENC) DTMESCOMPETENC
        FROM
            GPE_VINCULOH H1
        WHERE
                H1.NRVINCULOM = VH.NRVINCULOM
            AND H1.NRORG = VH.NRORG
            AND H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC
    )
WHERE
        AE.NRORG = :P_NRORG
    AND ( :P_NRVINCULOM IS NULL
          OR INSTR(','
                   || :P_NRVINCULOM
                   || ',', ','
                           || AE.NRVINCULOM
                           || ',') > 0 )
    AND ( :P_DTINICIO IS NULL
          OR TRUNC(AE.DTINIESCALA) >= :P_DTINICIO )
    AND ( :P_DTFIM IS NULL
          OR TRUNC(AE.DTFIMESCALA) <= :P_DTFIM )
SQL;
            $params = array(
                'P_DTMESCOMPETENC' => $dtmescompetencia,
                'P_NRVINCULOM' => $nrvinculom,
                'P_DTINICIO' => $dtinicio,
                'P_DTFIM' => $dtfim,
                'P_NRORG' => $nrorg,
            );
            return $this->entityManager->getConnection()->fetchAll($query, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

}